             .title        "Namcot 3446 Reader Plugin"


;11/30/07 
;Written by BootGod
;Version 1.0
             
             ;vectors for standard system calls

send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

address:       .equ 00e0h
address_lo:    .equ 00e0h
address_hi:    .equ 00e1h
curbank:    .equ 00e2h
banksleft:    .equ 00e3h
ppuaddr: .equ 00e4h

uaddress:       .equ 00e6h
uaddress_lo:    .equ 00e6h
uaddress_hi:    .equ 00e7h

bank_lo:    .equ 00e8h
bank_hi:    .equ 00e9h

numpages_lo .equ 00eah
numpages_hi .equ 00ebh


temp_crc:    .equ 00ech

;plugin header defines
p_ver: = 1	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Namco 3446"
             .db " (INES 76)"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 128 >> 4,0 >> 4
             .db 128 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here

             ;check mirroring             

             ldx #00h
             
             lda #020h
             jsr wr_ppu
             lda #055h
             sta 2007h
             lda #0aah
             sta 2007h
             lda #024h
             jsr wr_ppu
             lda 2007h
             lda 2007h
             cmp #055h
             bne horz_mir
             lda 2007h
             cmp #0aah
             bne horz_mir
             lda #020h
             jsr wr_ppu
             lda #0aah
             sta 2007h
             lda #024h
             jsr wr_ppu
             lda 2007h
             lda 2007h
             cmp #0aah
             bne horz_mir
             inx

horz_mir:    txa
             jsr send_byte   ;send byte

got_prg:     lda #0
             jsr send_byte
             lda #2
             jsr send_byte
             lda #01h
             jsr send_byte	;send PRG header

             lda #16
             sta banksleft
             lda #0
             sta curbank

next_pbank:  lda #6
             sta 8000h
             lda curbank
             sta 8001h
             inc curbank

             lda #0
             sta address_lo
             lda #080h
             sta address_hi

             ldx #32		;8K banks
             ldy #0

send_pbank:  lda (address),y
             jsr send_byte
             iny
             bne send_pbank
             inc address_hi
             dex
             bne send_pbank
             dec banksleft
             bne next_pbank

;determine CHR ROM size

got_chr:     lda #0		;send CHR header
             jsr send_byte
             lda #2		;128K CHR
             jsr send_byte
             lda #002h
             jsr send_byte

             lda #0
             sta curbank
             lda #64
             sta banksleft
            
next_chr:    lda curbank
             jsr wr_cbank
             inc curbank
             lda #0
             jsr wr_ppu
             lda 2007h

             ldx #8		;2K banks
             ldy #0

dump_chr:    lda 2007h
             jsr send_byte
             iny
             bne dump_chr
             dex
             bne dump_chr
             dec banksleft
             bne next_chr

done:        lda #0
             jsr send_byte
             lda #0
             jsr send_byte
             lda #0
             jsr send_byte

             rts

wr_cbank:    sta bank_lo
             lda #2
             sta 08000h
             lda bank_lo
             sta 08001h		;select 2K bank at PPU $0000
             rts


             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

             .end
